#[compute]
#version 450

// could also specify the +1 in the shader code, but for simplicity of the repro project,
// let's not have an expression as an array length.
layout(constant_id = 0) const int POLYNOMIAL_DEGREE_PLUS_ONE = 1;
layout(constant_id = 1) const float X_SCALE = 1.0;

layout(local_size_x = 8, local_size_y = 1, local_size_z = 1) in;

layout(set = 0, binding = 0, std140) restrict uniform Coefficients {
	float c[POLYNOMIAL_DEGREE_PLUS_ONE];
} coefficients;
layout(set = 0, binding = 1, std430) restrict writeonly buffer Values {
	float data[];
} values;

void main() {
	float x = gl_GlobalInvocationID.x * X_SCALE;
	float value = 0;

	for (int exponent = 0; exponent < POLYNOMIAL_DEGREE_PLUS_ONE; exponent++) {
		value += coefficients.c[exponent] * pow(x, exponent);
	}

	values.data[gl_GlobalInvocationID.x] = value;
}
